<?php
namespace ypl;

class Actions {
    private $registerPostType;

    public function __construct() {
        $this->init();
    }

    public function init() {
        add_action('init', array($this, 'postType'));
        add_action('save_post_'.YPL_POST_TYPE, array($this, 'save'), 10, 3);
        add_action('admin_menu', array($this, 'addSubMenu'));
        Shortcode::getInstance();
        add_action('admin_head', array($this, 'adminHead'));
        add_action('manage_'.YPL_POST_TYPE.'_posts_custom_column' , array($this, 'tableColumnValues'), 10, 2);
        register_activation_hook(YPL_FILE_NAME, array($this, 'activate'));
    }

    public function tableColumnValues($column, $postId) {
        if ($column == 'shortcode') {
            echo '<input type="text" onfocus="this.select();" readonly value="[ypl_poll id='.$postId.']" class="large-text code">';
        }
    }

    public function adminHead() {
        echo "<script>jQuery(document).ready(function() {jQuery('a[href*=\"page=YPL-more-ideas\"]').css({color: 'rgb(85, 239, 195)'});jQuery('a[href*=\"page=YPL-support-page\"]').css({color: 'yellow', 'font-size': '15px'});jQuery('a[href*=\"page=YPL-support-page\"], a[href*=\"page=YPL-more-ideas\"]').bind('click', function(e) {e.preventDefault(); window.open('https://wordpress.org/support/plugin/poll-builder/')}) });</script>";
    }

    public function save($postId, $post, $update) {
        if(!$update) {
            return false;
        }

        $safePost = filter_input_array(INPUT_POST);
        $postData = Poll::parseYplDataFromData($safePost);
        $postData = apply_filters('yplSavedData', $postData);
        if(empty($postData)) {
            return false;
        }
        $postData['ypl-post-id'] = $postId;
        $data = $postData;
        ClassicPoll::create($data);
    }

    public function postType() {
        $this->registerPostType = new RegisterPostType();
    }

    public function addSubMenu() {
        $this->registerPostType->addSubMenu();
    }

    public function activate() {
        Installer::install();
    }
}

new Actions();