function YplAdmin() {

}

YplAdmin.prototype.init = function() {
	this.deleteResult();
	this.select2();
	this.crudinit();
	this.addAnswer();
	this.listeners();
};

YplAdmin.prototype.crudinit = function () {
	this.toggleAnwers();
	this.deleteAnswer();
};

YplAdmin.prototype.deleteAnswer = function () {
	var deleteOption = jQuery('.ypl-trash');

	if (!deleteOption.length) {
		return;
	}
	var that = this;

	deleteOption.bind('click', function () {
		var currentIndex = jQuery(this).data('index');
		that.deleteOption(currentIndex);
	});
};

YplAdmin.prototype.listeners = function () {
	var that = this;

	jQuery(window).bind('addedNewIcon', function () {
		that.crudinit();
	});
};

YplAdmin.prototype.addAnswer = function () {
	var addNewButton = jQuery('.ypl-add-new-buttton');

	if (!addNewButton.length) {
		return false;
	}
	var that = this;

	addNewButton.bind('click', function () {
		var settings = that.getFieldSettings();
		var index = (parseInt(settings.length) + 1);
		//var newContent = jQuery('.ypl-default-setting').html();
		jQuery.post(ajaxurl, {action: 'ypl_add_new_answer',nonce: YPL_ADMIN_DATA.nonce}, function (newContent) {

			newContent = that.replaceAll(newContent, '{currentIndex}', index);
			jQuery('.ypl-settings-wrapper').append(newContent);

			var options = jQuery('.current-option-wrapper-'+index).data('options');
			that.addOption(options);
			jQuery(window).trigger('addedNewIcon');
		});

	});
};

YplAdmin.prototype.addOption = function (newOption) {
	var settings = this.getFieldSettings();
	settings.push(newOption);

	this.updateOptions(settings);
};

YplAdmin.prototype.deleteOption = function (index) {
	var settings = this.getFieldSettings();

	if(!settings.length) {
		return false;
	}

	for(var i in settings) {
		var currentSetting = settings[i];

		if (currentSetting.currentIndex == index) {
			delete settings[i];
			jQuery('.current-option-wrapper-'+index).remove();
			break;
		}
	}

	this.updateOptions(settings);
};

YplAdmin.prototype.getFieldSettings = function () {
	var settings = jQuery('#ypl-options-settings').val();
	settings = jQuery.parseJSON(settings);

	return settings;
};

YplAdmin.prototype.updateOptions = function (settings) {
	jQuery('#ypl-options-settings').attr('value', JSON.stringify(settings));
};

YplAdmin.prototype.toggleAnwers = function() {
	var currentEdit =  jQuery('.ypl-edit');

	if (!currentEdit.length) {
		return false;
	}

	currentEdit.unbind('click').bind('click', function () {
		var current = jQuery(this);

		if (!current.length) {
			return false;
		}

		current.parents('.current-option-header').first().next().toggleClass('ypl-hide');
	});
};


YplAdmin.prototype.select2 = function() {
    var select2 = jQuery('.js-ypl-select');

    if(!select2.length) {
        return false;
    }

    select2.select2();
};

YplAdmin.prototype.deleteResult = function() {
	jQuery('.subs-bulk').bind('change', function() {
		var isChecked = jQuery(this).is(':checked');
		jQuery('.ypl-delete-checkbox, .subs-bulk').prop('checked', isChecked);
	});
	var that = this;

	jQuery('#post-query-submit').bind('click', function(e) {
		e.preventDefault();
		var action = jQuery('.ypl-bulk-action');

		if(action.val() == 'delete') {
			// delete
			that.deleteSelected();
		}
	});
};

YplAdmin.prototype.deleteSelected = function() {
	var checkboxes = jQuery('.ypl-delete-checkbox');
 
	if (!checkboxes.length) {
		return false;
	}
	var idsList = [];

	checkboxes.each(function() {
		if (jQuery(this).is(':checked')) {
			idsList.push(jQuery(this).data('delete-id'));
		}
	});

	var data = {
		action: 'ypl_delete_result',
		idsList: idsList
	};

	jQuery.post(ajaxurl, data, function(result) {
		window.location.reload();
	})
};

YplAdmin.prototype.replaceAll = function(str, find, replace) {
	return str.replace(new RegExp(find, 'g'), replace);
};

jQuery(document).ready(function() {
	var obj = new YplAdmin();
	obj.init();
});